import { Endpoints } from "@octokit/types";
import { WorkflowRunRequestedEvent, WorkflowRunInProgressEvent, WorkflowRunCompletedEvent } from "@octokit/webhooks-types";
import { App } from "octokit";
export interface WorkflowRunLogs {
    name: string;
    lines: {
        time: string;
        text: string;
    }[];
    steps: {
        name: string;
        lines: {
            time: string;
            text: string;
        }[];
    }[];
}
export { App } from "octokit";
export declare class WorkflowDispatch {
    app: App;
    private pendingDispatches;
    private source;
    private port;
    private events;
    private smee?;
    private server;
    constructor(app: App, port?: number, webhookProxyUrl?: string | undefined);
    private setupSmee;
    private onWorkflowRun;
    workflowDispatchSync: (parameters: Endpoints["POST /repos/{owner}/{repo}/actions/workflows/{workflow_id}/dispatches"]["parameters"], requested?: ((run: WorkflowRunRequestedEvent) => void) | undefined, progress?: ((run: WorkflowRunInProgressEvent) => void) | undefined) => Promise<WorkflowRunCompletedEvent>;
    getWorkflowRunLogs: (parameters: Endpoints["GET /repos/{owner}/{repo}/actions/runs/{run_id}/logs"]["parameters"]) => Promise<WorkflowRunLogs[]>;
    close: () => void;
}
