"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WorkflowDispatch = exports.App = void 0;
const node_http_1 = require("node:http");
const octokit_1 = require("octokit");
const web_1 = require("node:stream/web");
globalThis.TransformStream = web_1.TransformStream;
const zip = __importStar(require("@zip.js/zip.js"));
const SmeeClient = require('smee-client');
const eventsource_1 = __importDefault(require("eventsource"));
const uuid_1 = require("uuid");
;
var octokit_2 = require("octokit");
Object.defineProperty(exports, "App", { enumerable: true, get: function () { return octokit_2.App; } });
class WorkflowDispatch {
    constructor(app, port = 3000, webhookProxyUrl = process.env.WEBHOOK_PROXY_URL) {
        this.pendingDispatches = [];
        this.setupSmee = (webhookProxyUrl) => {
            this.smee = new SmeeClient({
                source: webhookProxyUrl,
                target: `http://localhost:${this.port}/`,
                logger: console
            });
            this.source = new eventsource_1.default(webhookProxyUrl);
            this.source.onmessage = (event) => {
                const webhookEvent = JSON.parse(event.data);
                this.app.webhooks
                    .verifyAndReceive({
                    id: webhookEvent["x-request-id"],
                    name: webhookEvent["x-github-event"],
                    signature: webhookEvent["x-hub-signature"],
                    payload: webhookEvent.body,
                })
                    .catch(console.error);
            };
            return this.smee;
        };
        this.onWorkflowRun = ({ octokit, payload }) => __awaiter(this, void 0, void 0, function* () {
            const jobsResponse = yield octokit.request(payload.workflow_run.jobs_url);
            jobsResponse.data.jobs.forEach((job) => {
                job.steps.forEach((step) => {
                    const dispatch = this.pendingDispatches.find((dispatch) => dispatch.uid === step.name);
                    if (dispatch) {
                        switch (payload.action) {
                            case 'completed':
                                dispatch.resolve(payload);
                                break;
                            case 'requested':
                                if (dispatch.requested)
                                    dispatch.requested(payload);
                                break;
                            case 'in_progress':
                                if (dispatch.progress)
                                    dispatch.progress(payload);
                                break;
                        }
                    }
                });
            });
        });
        this.workflowDispatchSync = (parameters, requested, progress) => __awaiter(this, void 0, void 0, function* () {
            var _a, e_1, _b, _c;
            if (!parameters.inputs)
                parameters.inputs = {};
            if (!parameters.inputs.uid)
                parameters.inputs.uid = (0, uuid_1.v4)();
            try {
                for (var _d = true, _e = __asyncValues(this.app.eachRepository.iterator()), _f; _f = yield _e.next(), _a = _f.done, !_a;) {
                    _c = _f.value;
                    _d = false;
                    try {
                        const { octokit, repository } = _c;
                        if (repository.name !== parameters.repo)
                            continue;
                        yield octokit.rest.actions.createWorkflowDispatch(parameters);
                    }
                    finally {
                        _d = true;
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = _e.return)) yield _b.call(_e);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return new Promise((resolve, reject) => {
                var _a;
                this.pendingDispatches.push({
                    uid: (_a = parameters.inputs) === null || _a === void 0 ? void 0 : _a.uid,
                    requested,
                    progress,
                    resolve,
                    reject
                });
            }).finally(() => {
                const index = this.pendingDispatches.findIndex((dispatch) => { var _a; return dispatch.uid === ((_a = parameters.inputs) === null || _a === void 0 ? void 0 : _a.uid); });
                if (index >= 0)
                    this.pendingDispatches.splice(index, 1);
            });
        });
        this.getWorkflowRunLogs = (parameters) => __awaiter(this, void 0, void 0, function* () {
            var _g, e_2, _h, _j;
            var _k;
            const logs = [];
            try {
                for (var _l = true, _m = __asyncValues(this.app.eachRepository.iterator()), _o; _o = yield _m.next(), _g = _o.done, !_g;) {
                    _j = _o.value;
                    _l = false;
                    try {
                        const { octokit, repository } = _j;
                        if (repository.name !== parameters.repo)
                            continue;
                        const logsReponse = yield octokit.rest.actions.downloadWorkflowRunLogs(parameters);
                        const blob = new Blob([logsReponse.data]);
                        const files = yield (new zip.ZipReader(new zip.BlobReader(blob))).getEntries({ filenameEncoding: "utf-8" });
                        const cleanFileName = (fileName) => {
                            const matches = fileName.match(/\d+_(.*)\.txt/);
                            return matches ? matches[1] : fileName;
                        };
                        for (const file of files) {
                            if (file.directory)
                                continue;
                            if (!file.getData)
                                continue;
                            const text = yield file.getData(new zip.TextWriter());
                            const lines = (_k = text.split('\n')) === null || _k === void 0 ? void 0 : _k.map((line) => {
                                if (line.length < 28)
                                    return;
                                return {
                                    time: line.substring(0, 28),
                                    text: line.substring(29)
                                };
                            }).filter(line => line);
                            if (file.filename.includes('/')) {
                                const parts = file.filename.split('/');
                                const jobName = parts[0];
                                const stepName = cleanFileName(parts[1]);
                                const existingJob = logs.find((log) => log.name === jobName);
                                const step = {
                                    name: stepName,
                                    lines
                                };
                                if (existingJob) {
                                    existingJob.steps = existingJob.steps || [];
                                    existingJob.steps.push(step);
                                }
                                else {
                                    logs.push({
                                        name: jobName,
                                        steps: [step]
                                    });
                                }
                            }
                            else {
                                logs.push({
                                    name: cleanFileName(file.filename),
                                    lines,
                                    steps: []
                                });
                            }
                        }
                    }
                    finally {
                        _l = true;
                    }
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (!_l && !_g && (_h = _m.return)) yield _h.call(_m);
                }
                finally { if (e_2) throw e_2.error; }
            }
            return logs;
        });
        this.close = () => {
            this.events.close();
            this.source.close();
            this.server.close();
        };
        this.app = app;
        this.port = port;
        this.app.webhooks.on("workflow_run", this.onWorkflowRun);
        if (webhookProxyUrl) {
            console.log(`Setting up Smee with ${webhookProxyUrl}`);
            this.setupSmee(webhookProxyUrl);
            this.events = this.smee.start();
        }
        this.server = (0, node_http_1.createServer)((0, octokit_1.createNodeMiddleware)(app)).listen(port);
        if (this.events)
            this.events.close();
    }
}
exports.WorkflowDispatch = WorkflowDispatch;
